/*
 * TM.c
 *
 * Created: 27.3.2012 10:56:52
 *  Author: 119639
 */ 
#include "ks0108.h"
#include "Bitmap.h"
#define F_CPU 16000000UL	// frekvence hodinovho signlu (nutn pro delay.h)
#include <util/delay.h>     // hlavikov soubor pro zpodn
#include <avr/eeprom.h> 
volatile int *y;
volatile int *x;
volatile int first_start, touch, y_d, x_d,numbery,numberx; 
volatile uint8_t yAD,yAD_min,yAD_max;
volatile uint8_t xAD,xAD_min, xAD_max;
volatile uint8_t  right_calibration;
volatile uint8_t  way2 = 1;
volatile char compare_right [] = "CODE IS RIGHT" ;
volatile char compare_fail [] = "FAIL!!!" ;

volatile uint8_t axis;


void show_icon (unsigned char *icon, int icon_pos_x, int icon_pos_y, int raster)
{
	
int i, j,by,k;
//raster 32 or16
switch (raster)
{
 case 16: k = 2; break;
 case 32: k = 1; break;
 default: k = 1; break;		
}


 for(i=(icon_pos_y * (raster*k)); i<((icon_pos_y + 1)*(raster*k)); i+=8)
     {
		for(j=(icon_pos_x*raster); j<((icon_pos_x + 1)*raster); j++)
		{
			by = pgm_read_byte(icon++);
			ks0108GotoXY(j, i);
			ks0108WriteData(by);
		}	
   }		
}

void show_icon_invert (unsigned char *icon, int icon_pos_x, int icon_pos_y, int raster)
{
int i, j,by,k;
switch (raster)
{
 case 16: k = 2; break;
 case 32: k = 1; break;
 default: k = 1; break;		
}
	
//raster 32 or16

 for(i=(icon_pos_y * (raster*k)); i<((icon_pos_y + 1)*(raster*k)); i+=8)
     {
		for(j=(icon_pos_x*raster); j<((icon_pos_x + 1)*raster); j++)
		{
			by = pgm_read_byte(icon++);
			ks0108GotoXY(j, i);
			ks0108WriteData(~by);
		}	
   }		
}

void right_run1 (unsigned char *bitmap)
{
uint16_t i, j,z, by;
uint8_t x_max = 0;
int cykl;
unsigned char *bitmap2;


bitmap2 = bitmap;

for (z= 0; z < 127; z++)
{
 _delay_ms(50);
 x_max++;
 cykl = 0;
 
  for(i=0; i<64; i+=8)
  {
	bitmap = bitmap2;
	bitmap = bitmap+(cykl*128);
	cykl++;
    for(j=0; j<x_max; j++)
	{
	 by=pgm_read_byte(bitmap++);
	 ks0108GotoXY(j, i);
	 ks0108WriteData(by);
	}
  }			
}
}

void right_run2 (unsigned char *bitmap)
{
uint16_t i, j,z, by;
uint8_t x_max = 0;
int cykl;
unsigned char *bitmap2;

bitmap2 = bitmap;

for (z= 0; z < 127; z++)
{
 _delay_ms(50);
 x_max++;
 cykl = 0;
 
  for(i=0; i<64; i+=8)
  {
	bitmap = bitmap2;
	bitmap = bitmap+(cykl*128)+128-z;
	cykl++;
    for(j=0; j<x_max; j++)
	{
		by=pgm_read_byte(bitmap++);
		ks0108GotoXY(j, i);
		ks0108WriteData(by);
	}
  }			
}
}

void axis_AD_x (void)
{
  axis = 0;
  ADMUX =	0b00100010;
  DDRA =	0b01001001;  
  PORTA =	0b01010001; 
  ADCSRA =	0b11001111;
  _delay_ms(5);
}

void axis_AD_y (void)
{
  axis = 1; 
  ADMUX =	0b00100000;
  DDRA =	0b01000110; 
  PORTA =   0b00010010; 
  ADCSRA = 0b11001111;
  _delay_ms(5);
} 

void calibrate (void)
{	
 uint8_t addr_write, adrr_read;
 right_calibration = 0;
 ks0108ClearScreen();	
 int i,j,k,l,m;
 uint8_t data;
 volatile char xmin[10]; 
 volatile char xmax[10];
 volatile char ymin[10]; 
 volatile char ymax[10];
 
 for (m=0; m <= 3; m++ )
 {
	switch (m)
	{
	case 0:k=0;l=0;break;		
	case 1:k=122;l=0;break;	
	case 2:k=0; l=58;break;	
	case 3:k=122;l=58;break;	
	case 4:k=58;l=31;break;	
	case 5:break;	
	case 6:break;
	}
	
	for (i=0; i<=5; i++)
	{
	 for (j=0; j<=5; j++ )		
	 {
	  ks0108GotoXY(i+k, (j+l)-((j+l)%8));					
	  data = ks0108ReadData();	
	  data |= 0x01 << ((j+l)%8);	
	  ks0108WriteData(data);	
     }
    }
	
   _delay_ms(2000);
   axis_AD_x();   	
   xAD = *x;
   axis_AD_y();   	
   yAD = *y;
   _delay_ms(2000);	
   
   switch (m)
	{
	case 0:yAD_min = yAD; xAD_min = xAD;break;		
	case 1:xAD_max = xAD;break;	
	case 2:yAD_max = yAD;break;	
	case 3:break;	
	case 4:break;	
	case 5:break;	
	case 6:break;
	} 
 
      addr_write=0; 
      eeprom_write_byte((uint8_t *)addr_write,yAD_min) ; 
      _delay_ms(1); 
      addr_write=1; 
      eeprom_write_byte((uint8_t *)addr_write,yAD_max) ; 
      _delay_ms(1); 
	  addr_write=2; 
      eeprom_write_byte((uint8_t *)addr_write,xAD_min) ; 
      _delay_ms(1); 
      addr_write=3; 
      eeprom_write_byte((uint8_t *)addr_write,xAD_max) ; 
      _delay_ms(1);
	 ks0108ClearScreen();
	 
 }
 
 ks0108ClearScreen();
 
 right_calibration = 1;
} 		

void screen_saver (char *text)
{
int length_text, wall, last_wall,x,y,change1,change2,change3,change4,stop;
length_text = sizeof(text);
wall = 2;  
last_wall = 1;
y = 30;
x = 50;
change1,change2,change3,change4 = 1;


while (stop == 0)
{
 switch (wall) 	
 {
 case 1:
 
 if(last_wall == 2)
 {
  while((y != 0) && (x != (123 - length_text*10)))
  {
   x++;
   y--; 
   ks0108ClearScreen();
   ks0108GotoXY(x,y);
   ks0108Puts(text);
   stop = touch_scan();
   if (stop == 1)
   {
    return (0);
   }
   _delay_ms(100);
  }
  
  if (x == (123 - (length_text*10)) && (y != 0) )
  {
   wall = 3;
   last_wall = 1; 
  }
    if (y == 0)
  {
   wall = 4;
   last_wall = 1; 
   y++;
  }
 }

 if(last_wall == 4)
 {
  while((y < 48) && (x != 123-(length_text*10)))
  {
   x++;
   y++; 
   ks0108ClearScreen();
   ks0108GotoXY(x,y);
   ks0108Puts(text);
   stop = touch_scan();
   if (stop == 1)
   {
    return (0);
   }
   _delay_ms(100);
  }
  
  if ((x == 123 - (length_text*10))&&(y !=48))
 {
  wall = 3;
  last_wall =1; 
 }
 
  if (y==48)
  {
   wall = 2;
   last_wall = 1; 
   y--;
  }
 }

break;

case 2:

if(last_wall == 1)
{
 while((y!=0) && (x!=123-(length_text*10)))
 {
  x++;
  y--; 
  ks0108ClearScreen();
  ks0108GotoXY(x,y);
  ks0108Puts(text);
  stop = touch_scan();
  if (stop == 1)
  {
   return (0);
  }
  _delay_ms(100);
 }
 
  if (x == 123-(length_text*12))
 {
  wall = 4;
  last_wall = 3; 
  x--;
 }
 
  if (y==0)
 {
  wall = 4;
  last_wall = 1; 
  y++;
 }
}

if(last_wall == 3)
{
 while((x!=0) && (y != 0) )
 {
  x--;
  y--; 
  ks0108ClearScreen();
  ks0108GotoXY(x,y);
  ks0108Puts(text);
  stop = touch_scan();
  if (stop == 1)
  {
   return (0);
  }
  _delay_ms(100);
 }
 
  if (x==0)
 {
  wall = 1;
  last_wall = 2; 
  x++;
 }
 
  if (y==0)
 {
  wall = 4;
  last_wall = 3; 
  y++;
 }
} 

if((last_wall == 4) && (way2 == 1)) 
{
 while((x!=0) && (y != 0) )
 {
  x--;
  y--; 
  ks0108ClearScreen();
  ks0108GotoXY(x,y);
  ks0108Puts(text);
  stop = touch_scan();
  if (stop == 1)
  {
   return (0);
  }
  _delay_ms(100);
 }
 
  if (x==0)
 {
  wall = 1;
  last_wall = 2; 
  way2 = 3;
  x--;
 }
} 

if((last_wall == 4) && (way2 == 3)) 
{
 while((x!=0) && (y != 0) )
 {
  x++;
  y--; 
  ks0108ClearScreen();
  ks0108GotoXY(x,y);
  ks0108Puts(text);
  stop = touch_scan();
  if (stop == 1)
  {
   return (0);
  }
  _delay_ms(100);
 }
 
  if (x==0)
 {
  wall = 3;
  last_wall = 2;
  way2 = 1; 
  x++;
 }
} 
 
 if (y==0)
 {
  wall = 4;
  last_wall = 1; 
  y++;
 }
 
break;
 
case 3:

if(last_wall == 2)
{
 while((y!=0) && (x!=0))
 {
  x--;
  y--; 
  ks0108ClearScreen();
  ks0108GotoXY(x,y);
  ks0108Puts(text);
  stop = touch_scan();
  if (stop == 1)
  {
   return (0);
  }
  _delay_ms(100);
 }
 if (y == 0)
 {
  wall = 4;
  last_wall = 3; 
  y++;
 }
 
  if (x == 0)
 {
  wall = 4;
  last_wall = 1; 
  y++;
 }
}

if(last_wall == 4)
{
 while(y != 48)
 {
  x--;
  y++; 
  ks0108ClearScreen();
  ks0108GotoXY(x,y);
  ks0108Puts(text);
  stop = touch_scan();
  if (stop == 1)
  {
   return (0);
  }
  _delay_ms(100);
 }
 
 if (y == 48)
 {
  wall = 2;
  last_wall = 3; 
  y--;
 }
 
 if (x == (123-(length_text*10)))
 {
  wall = 1;
  last_wall = 4; 
  x++;
 }
} 

if(last_wall == 1)
{
 while((y!=0) && (x!=0))
 {
  x--;
  y--; 
  ks0108ClearScreen();
  ks0108GotoXY(x,y);
  ks0108Puts(text);
  stop = touch_scan();
  if (stop == 1)
  {
   return (0);
  }
  _delay_ms(100);
 }
 if (y == 0)
 {
  wall = 4;
  last_wall = 3; 
  y++;
 }
 
  if (x == 0)
 {
  wall = 4;
  last_wall = 1; 
  y++;
 }
}
break;

case 4:

if(last_wall == 3)
{
 while((y!=48) && (x != 0))
 {
  x--;
  y++; 
  ks0108ClearScreen();
  ks0108GotoXY(x,y);
  ks0108Puts(text);
  stop = touch_scan();
  if (stop == 1)
  {
   return (0);
  }
  _delay_ms(100);
 }
 if (y==48)
 {
  wall = 1;
  last_wall = 4; 
  y--;
 }
 
 if (x == 0)
 {
  wall = 2;
  last_wall = 1; 
 }
}

if(last_wall == 1)
{
 while((y!=48) && (x!=123-(length_text*10)))
 {
  x++;
  y++; 
  ks0108ClearScreen();
  ks0108GotoXY(x,y);
  ks0108Puts(text);
  stop = touch_scan();
  if (stop == 1)
  {
   return (0);
  }
  _delay_ms(100);
 }
 if (y == 48)
 {
  wall = 2;
  last_wall = 3; 
  y--;
 }
 
  if (x == (123-(length_text*10)))
 {
  wall = 3;
  last_wall = 4; 
  x--;
 }
}

if(last_wall == 2)
{
 while((y!=0) && (x!=123-(length_text*10)))
 {
  x++;
  y++; 
  ks0108ClearScreen();
  ks0108GotoXY(x,y);
  ks0108Puts(text);
  stop = touch_scan();
  if (stop == 1)
  {
   return (0);
  }
  _delay_ms(100);
 }
 if (y==48)
 {
  wall = 2;
  last_wall = 1; 
  y--;
 }
 
  if (x == (123-(length_text*10)))
 {
  wall = 3;
  last_wall = 4;
  x--; 
 }
}
break;	
}	
}
}	

int touch_scan (void)
{
 int i, equal;
 uint8_t touch_control[20];
 
 
	  for (i = 0; i <= 8; i++)
	  {		
	   axis_AD_x();  
	   touch_control[i] = *x;   
	   
	   if (touch_control[i] ==  touch_control[i-1])
	   {
	    equal++;		   
	   }
	   else
	   {
		equal = 0;   
	   }
	   
	   if (equal == 4)
	   {
	    return (1);		   
	   }
	  }
	  
	return (0);		 
}

unsigned long int show_numpad (unsigned char *numeric_pad, unsigned long int password)
{
	int number_position = 0;
	unsigned long int number_key = 0; 
	uint8_t right_touch, stop = 0;
	ks0108ClearScreen();
	LoadBitmap(numeric_pad);
	
while (stop == 0)
{

  right_touch =  touch_scan();
	
  if (right_touch == 1) 
  {
		
    axis_AD_y();	   
    axis_AD_x();

	if((*x <= 27) && (*x >= 0) && (*y >= 0)  && (*y <= 21) )
    {	
	  number_key = number_key*10;
	  ks0108GotoXY(10 + number_position,47);
	  ks0108PutChar('1');
	  number_key += 1;
	  number_position +=10;
	  _delay_ms(500);
	 }
	   
	if((*x <= 51) && (*x >= 28) && (*y >= 0)  && (*y <= 21) )
    {	 
	  number_key = number_key*10;
	  ks0108GotoXY(10 + number_position,47);
	  ks0108PutChar('2');
	  number_key += 2;
	  number_position +=10;
	  _delay_ms(500);
	}
	
	if((*x <= 75) && (*x >= 52) && (*y >= 0)  && (*y <= 21) )
    {	
	  number_key = number_key*10; 
	  ks0108GotoXY(10 + number_position,47);
	  ks0108PutChar('3');
	  number_key += 3;
	  number_position +=10;
	  _delay_ms(500);
	 }
	   
	if((*x <= 99) && (*x >= 76) && (*y >= 0)  && (*y <= 21) )
    {
	  number_key = number_key*10;	  
	  ks0108GotoXY(10 + number_position,47);
	  ks0108PutChar('4');
	  number_key += 4;
	  number_position +=10;
	  _delay_ms(500);
	}
	
	if((*x <= 128) && (*x >= 100) && (*y >= 0)  && (*y <= 21) )
    {	
	  number_key = number_key*10;  
	  ks0108GotoXY(10 + number_position,47);
	  ks0108PutChar('5');
	  number_key += 5;
	  number_position +=10;
	  _delay_ms(500);
	}
	
	//second line
	
	if((*x <= 27) && (*x >= 0) && (*y >= 22)  && (*y <= 41) )
    {
	  number_key = number_key*10;	  
	  ks0108GotoXY(10 + number_position,47);
	  ks0108PutChar('6');
	  number_key += 6;
	  number_position +=10;
	  _delay_ms(500);
	 }
	   
	if((*x <= 51) && (*x >= 28) && (*y >= 22)  && (*y <= 41) )
    {	
	  number_key = number_key*10;  
	  ks0108GotoXY(10 + number_position,47);
	  ks0108PutChar('7');
	  number_key += 7;
	  number_position +=10;
	  _delay_ms(500);
	}
	
	if((*x <= 75) && (*x >= 52) && (*y >= 22)  && (*y <= 41) )
    {
	  number_key = number_key*10;	  
	  ks0108GotoXY(10 + number_position,47);
	  ks0108PutChar('8');
	  number_key += 8;
	  number_position +=10;
	  _delay_ms(500);
	 }
	   
	if((*x <= 99) && (*x >= 76) && (*y >= 22) && (*y <= 41) )
    {
	  number_key = number_key*10;	  
	  ks0108GotoXY(10 + number_position,47);
	  ks0108PutChar('9');
	  number_key += 9;
	  number_position +=10;
	  _delay_ms(500);
	}
	
	if((*x <= 128) && (*x >= 100) && (*y >= 22)  && (*y <= 41) )
    {	
	  number_key = number_key*10;  
	  ks0108GotoXY(10 + number_position,47);
	  ks0108PutChar('0');
	  number_key += 0;
	  number_position +=10;
	  _delay_ms(500);
	}
	
	// third line
	
	if((*x <= 99) && (*x >= 76) && (*y >= 42)  && (*y <= 64) )
    {	  
	  ks0108ClearScreen();
	  
	  if (number_key == password)
	  {
	   ks0108GotoXY(15,28);
	   ks0108Puts(compare_right);	 
	   _delay_ms(2000);  
	   stop = 1;
	  }
	  
	  else
	  {
	   ks0108GotoXY(40,28);
	   ks0108Puts(compare_fail);	
	   _delay_ms(2000); 
	   LoadBitmap(numeric_pad);
	   number_position = 0;	  
	   number_key = 0;
	  }
	  
	  LoadBitmap(numeric_pad);
	  number_position = 0;
	}
	
	if((*x <= 128) && (*x >= 100) && (*y >= 42)  && (*y <= 64 ))
    {	  
	  _delay_ms(100);
	  ks0108ClearScreen();
	  stop = 1;
	}
  }
}
return (number_key);
}
